
#line 1 "ansi_parser.rl"
#include <fmt/core.h>
#include <string_view>
#include "dbc.hpp"
#include <SFML/Graphics.hpp>
#include "ansi_parser.hpp"
#include <iostream>

using namespace fmt;


#line 105 "ansi_parser.rl"



#line 13 "ansi_parser.cpp"
static const char _foo_actions[] = {
	0, 1, 0, 1, 3, 1, 4, 1, 
	5, 1, 6, 1, 7, 1, 8, 1, 
	9, 1, 10, 1, 14, 1, 15, 2, 
	1, 11, 2, 1, 12, 2, 15, 5, 
	3, 1, 13, 2
};

static const char _foo_key_offsets[] = {
	0, 0, 1, 2, 8, 9, 11, 12, 
	15, 16, 17, 18, 20, 23, 25, 28, 
	30, 33, 34, 37, 38, 39, 40, 41, 
	42
};

static const int _foo_trans_keys[] = {
	27, 91, 50, 51, 52, 55, 48, 54, 
	109, 55, 109, 109, 56, 57, 109, 59, 
	50, 59, 48, 57, 59, 48, 57, 48, 
	57, 59, 48, 57, 48, 57, 109, 48, 
	57, 109, 56, 57, 109, 59, 50, 109, 
	109, 27, 27, 0
};

static const char _foo_single_lengths[] = {
	0, 1, 1, 4, 1, 2, 1, 3, 
	1, 1, 1, 0, 1, 0, 1, 0, 
	1, 1, 3, 1, 1, 1, 1, 1, 
	1
};

static const char _foo_range_lengths[] = {
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 1, 1, 1, 1, 1, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	0
};

static const char _foo_index_offsets[] = {
	0, 0, 2, 4, 10, 12, 15, 17, 
	21, 23, 25, 27, 29, 32, 34, 37, 
	39, 42, 44, 48, 50, 52, 54, 56, 
	58
};

static const char _foo_trans_targs[] = {
	2, 1, 3, 0, 5, 7, 18, 22, 
	4, 0, 24, 0, 6, 24, 0, 24, 
	0, 8, 17, 24, 0, 9, 0, 10, 
	0, 11, 0, 12, 0, 13, 12, 0, 
	14, 0, 15, 14, 0, 16, 0, 24, 
	16, 0, 24, 0, 19, 21, 24, 0, 
	20, 0, 10, 0, 24, 0, 24, 0, 
	2, 1, 2, 1, 0
};

static const char _foo_trans_actions[] = {
	0, 7, 0, 0, 19, 19, 19, 19, 
	19, 0, 0, 0, 0, 17, 0, 15, 
	0, 0, 0, 0, 0, 0, 0, 3, 
	0, 0, 0, 1, 0, 23, 0, 0, 
	1, 0, 26, 0, 0, 1, 0, 32, 
	0, 0, 9, 0, 0, 0, 0, 0, 
	0, 0, 5, 0, 11, 0, 13, 0, 
	0, 7, 21, 29, 0
};

static const char _foo_eof_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	21
};

static const int foo_start = 23;
static const int foo_first_final = 23;
static const int foo_error = 0;

static const int foo_en_main = 23;


#line 108 "ansi_parser.rl"

#include <ftxui/screen/terminal.hpp>

ANSIParser::ANSIParser(sf::Color default_fg, sf::Color default_bg) :
  $default_fg(default_fg),
  $default_bg(default_bg)
{
  // the parser only handles full color so force it
  if(ftxui::Terminal::ColorSupport() != ftxui::Terminal::Color::TrueColor) {
    ftxui::Terminal::SetColorSupport(ftxui::Terminal::Color::TrueColor);
  }
}

bool ANSIParser::parse(std::wstring_view codes, ColorCB color_cb, WriteCB write_cb) {
  const wchar_t *start = NULL;
  int cs = 0;
  unsigned int value = 0;
  const wchar_t *p = codes.data();
  const wchar_t *pe = p + codes.size();
  const wchar_t *eof = pe;
  sf::Color bgcolor($default_bg);
  sf::Color color($default_fg);
  sf::Color &target = color;

  
#line 117 "ansi_parser.cpp"
	{
	cs = foo_start;
	}

#line 133 "ansi_parser.rl"
  
#line 120 "ansi_parser.cpp"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const int *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _foo_trans_keys + _foo_key_offsets[cs];
	_trans = _foo_index_offsets[cs];

	_klen = _foo_single_lengths[cs];
	if ( _klen > 0 ) {
		const int *_lower = _keys;
		const int *_mid;
		const int *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _foo_range_lengths[cs];
	if ( _klen > 0 ) {
		const int *_lower = _keys;
		const int *_mid;
		const int *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _foo_trans_targs[_trans];

	if ( _foo_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _foo_actions + _foo_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 14 "ansi_parser.rl"
	{
    start = p;
  }
	break;
	case 1:
#line 18 "ansi_parser.rl"
	{
    value = 0;
    size_t len = p - start;
    dbc::check(start[0] != '-', "negative numbers not supported");

    switch(len) {
      case 10:    value += (start[len-10] - '0') * 1000000000;
      case  9:    value += (start[len- 9] - '0') * 100000000;
      case  8:    value += (start[len- 8] - '0') * 10000000;
      case  7:    value += (start[len- 7] - '0') * 1000000;
      case  6:    value += (start[len- 6] - '0') * 100000;
      case  5:    value += (start[len- 5] - '0') * 10000;
      case  4:    value += (start[len- 4] - '0') * 1000;
      case  3:    value += (start[len- 3] - '0') * 100;
      case  2:    value += (start[len- 2] - '0') * 10;
      case  1:    value += (start[len- 1] - '0');
        break;
      default:
        dbc::sentinel("can't process > 10 digits");
    }
  }
	break;
	case 2:
#line 40 "ansi_parser.rl"
	{
    color_cb(color, bgcolor);
  }
	break;
	case 3:
#line 43 "ansi_parser.rl"
	{
    target = color;
  }
	break;
	case 4:
#line 46 "ansi_parser.rl"
	{
    target = bgcolor;
  }
	break;
	case 5:
#line 50 "ansi_parser.rl"
	{
    write_cb((*p));
  }
	break;
	case 6:
#line 54 "ansi_parser.rl"
	{ color = $default_fg; }
	break;
	case 7:
#line 55 "ansi_parser.rl"
	{ bgcolor = $default_bg; }
	break;
	case 8:
#line 56 "ansi_parser.rl"
	{
    color = {100,100,100}; // UNDO THIS
    bgcolor = $default_bg; // THIS TOO
    color_cb(color, bgcolor);
  }
	break;
	case 9:
#line 61 "ansi_parser.rl"
	{
    color = $default_fg;
    bgcolor = $default_bg;
    color_cb(color, bgcolor);
  }
	break;
	case 10:
#line 66 "ansi_parser.rl"
	{
  }
	break;
	case 11:
#line 69 "ansi_parser.rl"
	{ target.r = value; }
	break;
	case 12:
#line 70 "ansi_parser.rl"
	{ target.g = value; }
	break;
	case 13:
#line 71 "ansi_parser.rl"
	{ target.b = value; }
	break;
	case 14:
#line 72 "ansi_parser.rl"
	{ value = 0; }
	break;
	case 15:
#line 73 "ansi_parser.rl"
	{}
	break;
#line 279 "ansi_parser.cpp"
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	const char *__acts = _foo_actions + _foo_eof_actions[cs];
	unsigned int __nacts = (unsigned int) *__acts++;
	while ( __nacts-- > 0 ) {
		switch ( *__acts++ ) {
	case 15:
#line 73 "ansi_parser.rl"
	{}
	break;
#line 297 "ansi_parser.cpp"
		}
	}
	}

	_out: {}
	}

#line 134 "ansi_parser.rl"

  bool good = p - pe == 0;

  if(!good) {
    println("FAIL AT {}", p - pe);
    // dear cthuhlu, save me from the pain that is wstring
    for(int i = 0; i < 100; i++) {
      print("{}", char(p[i]));
    }
  }

  return good;
}
